# short34.py Quelle: short31.py
import pygame
import serial
import time
import draw16 as DrawM
import RDstr33 as RDstr

from Variables8 import *

fcsv = CSV_FILE
#fcsv = "/home/pi/Documents/pySTW08.csv"
#fcsv = "/home/pi/Documents/pySTWe05.csv"

ser=serial.Serial(COM_PORT,9600,timeout=3)

enc = str.encode('Rasp start'+'\n')
ser.write(enc)

pygame.init()
pygame.display.set_caption(__file__ +'  ' + fcsv)

sx = ElanzX * elx + 2 * offs
#sy = ElanzY * (ely+1) + 3 * offs
sy = ElanzY * (ely+1) + (3 * offs) + 10
size = sx, sy
fenster=pygame.display.set_mode(size)

font = pygame.font.SysFont("arial",12)  #nach display.
#text = font.render("Max",True, BLACK)

# Array StpM

dim_y, dim_x = ElanzY, ElanzX
# Y       X                                       # +1 wegen Rand
StpM=[[0] * (dim_x+1) for i in range(dim_y+1)]    # Elemente und Lage
StpA=[[0] * (dim_x+1) for i in range(dim_y+1)]    # Adressen
StpS=[[0] * (dim_x+1) for i in range(dim_y+1)]    # Signale

print('size StpM x,y:', len(StpM[0]),len(StpM))
Wcnt = 0
Wlist=[[0] * 6 for i in range(20)]          # Liste aller Weichen
print('Wlist:',Wlist[2])                    # Wlist: [0, 0, 0, 0, 0, 0]


#print (StpM[15][25])
#            y    x

Lcnt = 0
StpM,Lcnt = RDstr.RDcsv(fcsv)
print("Zeilen:",Lcnt)


Ylen= len(StpM)
print(f'lenStpM: {Ylen}')

# StpM[][] komplett ausgeben
#for t in range (0,Ylen):    
#    print(f'{t}: {StpM[t]}')
  

# ---Fortsetzung am Programmende -----------------------

# ------------------------------------------------------






def textInfo(x,y,String):
    cx =offs-20+elx/2
    cy =offs+ely
    Ele = int(StpM[y][x]) & 0X1F
    Korx = 18   #default
    Kory = 15
    
    if (Ele == 1) or (Ele == 2) or (Ele == 3):
        Korx = 30; Kory = 0
    elif (Ele == 24) or (Ele == 8):      # oben rechts
        Korx = 40; Kory = 2
    elif (Ele == 9):                     # unten rechts
        Korx = 40; Kory = 26
    elif (Ele == 12) or (Ele == 10):     # DKW
        Korx = 4; Kory = 26              # unten links
    elif (Ele == 13) or (Ele == 25) or (Ele == 11): # DKW
        Korx = 4; Kory = 2               # oben links
    elif (Ele == 16) or (Ele == 19):     # Schrift oben
        Kory = 2
    elif (Ele == 17) or (Ele == 18):     # Schrift unten
        Kory = 27
    
    cx = cx + Korx
    cy = cy + Kory
    text = font.render(str(String),True, BLACK)
    fenster.blit(text, (round(x*elx+cx),round((y-1)*ely+cy)))
    return

def textStrS(x,y,String):   # Statusmeldung
    cx =offs-20+elx/2
    cy =offs+ely/2
    string = String[2:]     #2 Zeichen links entfernen    
    text = font.render(str(string),True, BLACK)
    fenster.blit(text, (round(x*elx+cx),round(y*ely+cy)))
    return


def textStr(x,y,String):   #zunächst Elementbeschriftungen
    cx =offs-20+elx/2
    cy =offs+ely/2
    text = font.render(str(String),True, BLACK)
    fenster.blit(text, (round(x*elx+cx),round(y*ely+cy)))
    return

def textStrC(x,y,String,color):   
    cx =offs-20+elx/2
    cy =offs+ely/2
    text = font.render(str(String),True, color)
    fenster.blit(text, (round(x*elx+cx),round(y*ely+cy)))
    return

def textButt(x,y,String):   # Text FwegButton
    cx =offs-12 +elx/2
    cy =offs-20 +ely/2
    text = font.render(str(String),True, BLACK)
    fenster.blit(text, (round(x*elx+cx),round(y*ely+cy)))
    return


def reck(col,x1,y1,x2,y2,lt):
    pygame.draw.rect(fenster,col,((x1,y1),(x2,y2)),lt)
    return 0

def reckf(col,x1,y1,x2,y2):
    pygame.draw.rect(fenster,col,((x1,y1),(x2,y2)))
    return 0

def track(x,y):
    px = x*elx+offs; py = y*ely+offs
    pygame.draw.rect(fenster,BLACK,((px,py+16),(elx,9)))
    return 0

def trackl(x,y,col):
    px = x*elx+offs; py = y*ely+offs
    pygame.draw.rect(fenster,col,((px+10,py+18),(elx-20,5)))
    return 0

"""
def stric(x1,y1,x2,y2,col,lt):
    pygame.draw.line(fenster,col,(x1,y1),(x2,y2),lt)
    return 0
"""

def cross(x,y):                     #Test erf., stri() not defined
    px = x*elx+offs; py = y*ely+offs
    stri(px,py,px+elx,py+ely,2)
    return

def crossc(x,y,col):
    px = x*elx+offs; py = y*ely+offs
    DrawM.stric(px,py,px+elx,py+ely,col,2,fenster)
    return

def grid():
    for i in range(offs,sx,ely):   # linie horizontal         
        text = font.render(str(int(i/ely)),True, BLACK)
        fenster.blit(text, (0,i+10))                               # nummern vertikal
        pygame.draw.line(fenster,BLACK,(int(offs),int(i)),(int(sx-offs-2),int(i))) # linie horizontal
                                   #      x1        y1          x2          y2
    for i in range(14,sx,elx):     # linie vertikal              
        text = font.render(str(int(i/elx)),True, BLACK)
        fenster.blit(text, (i+20,0))                               # nummern horizontal
        pygame.draw.line(fenster,BLACK,(i,offs),(i,sy-15),1)        # linie vertikal
    return

def kink(x,y,corner):
    cx = int(x * elx + (elx/2))
    cy = int(y * ely + (ely/2))
    cx = int(cx + offs)
    cy = int(cy + offs)    
    px1=12;     py1=int(TRACK/2)
    px2=-7;     py2=int(-py1 -1)
    px3=int(-elx/2); py3=int(py2)
    px4=int(px3);    py4=int(py1)
    
    if (corner == 1):
        py1=-py1; py2=-py2; py3= -py3; py4=-py4; 
    elif (corner==2):
        py1=-py1; py2=-py2; py3= -py3; py4=-py4; 
        px1=-px1; px2=-px2; px3= -px3; px4=-px4; 
    elif (corner==3):
        px1=-px1; px2=-px2; px3= -px3; px4=-px4;             
        
    pygame.draw.polygon(fenster,BLACK,[(px1+cx,py1+cy),(px2+cx,py2+cy),(px3+cx,py3+cy),(px4+cx,py4+cy)])
    return

def arrow(x,y,corner):
    #px = x*elx+offs; py = y*ely+offs
    cx = int(x * elx + (elx/2))
    cy = int(y * ely + (ely/2))
    cx = int(cx + offs)
    cy = int(cy + offs)
    px1=int(elx/2);py1=int(ely/2)
    px2=int(px1);  py2=int(py1-7)
    px3=12;   py3=9/2
    px4=-10;  py4=int(py3)
    px5=int(px1-7);py5=int(py1)    
          
    if (corner == 1):
        py1=-py1; py2=-py2; py3= -py3; py4=-py4; py5=-py5
    elif (corner==2):
        py1=-py1; py2=-py2; py3= -py3; py4=-py4; py5=-py5
        px1=-px1; px2=-px2; px3= -px3; px4=-px4; px5=-px5 
    elif (corner==3):
        px1=-px1; px2=-px2; px3= -px3; px4=-px4; px5=-px5               
    a1 = round(px1+cx); b1 = round(py1+cy)
    a2 = round(px2+cx); b2 = round(py2+cy)
    a3 = round(px3+cx); b3 = round(py3+cy)
    a4 = round(px4+cx); b4 = round(py4+cy)
    a5 = round(px5+cx); b5 = round(py5+cy)
    
    pygame.draw.polygon(fenster,BLACK,[(a1,b1),(a2,b2),(a3,b3),(a4,b4),(a5,b5)])
    return

def TrackSlant(x,y,corner):   #Diagonale
    ex = x * elx + offs
    ey = y * ely + offs
    
    px1=elx;  py1=ely
    px2=elx;  py2=ely-7
    px3=7;    py3=0
    px4=0;    py4=0
    px5=0;    py5=7
    px6=elx-7;py6=ely
    
    if ((corner == 1) or (corner == 3)):
        px1=0;
        px2=7;    py2=ely
        px3=elx;  py3=7
        px4=elx;  py4=0
        px5=elx-7;py5=0
        px6=0;    py6=ely-7
    pygame.draw.polygon(fenster,BLACK,[(px1+ex,py1+ey),(px2+ex,py2+ey),(px3+ex,py3+ey),
                                       (px4+ex,py4+ey),(px5+ex,py5+ey),(px6+ex,py6+ey)])
    return       

def TrackHLine(x,y,corner):
    cx = x * elx + (elx/2)
    cy = y * ely + (ely/2)
    cx = cx + offs
    cy = cy + offs
    px1 = cx -elx/2; py1 = cy -TRACK/2
        
    if ((corner == 2) or (corner == 3)):
        px1 = cx
                
    pygame.draw.rect(fenster,BLACK,(round(px1),round(py1),round(elx/2),TRACK))
    return
 
def SymKr(x,y):
    TrackSlant(x,y,0)
    TrackSlant(x,y,3)
    TurnoutLong(x,y,0,GRAY)
    TurnoutLong(x,y,3,GRAY)
    return

def DKW (x,y, corner):
    TrackSlant(x,y,corner)
    track(x,y)
    cx = x * elx + (elx/2)
    cy = y * ely + (ely/2)
    cx = cx + offs
    cy = cy + offs
    
    print('corner:',corner)
    
    if (corner == 0) or (corner == 2):        
        TurnoutDir(x,y,2,GRAY)
        TurnoutPos(x,y,2,GRAY)
        TurnoutDir(x,y,0,GRAY)
        TurnoutPos(x,y,0,GRAY)
    else:
        TurnoutDir(x,y,3,GRAY)
        TurnoutPos(x,y,3,GRAY)
        TurnoutDir(x,y,1,GRAY)
        TurnoutPos(x,y,1,GRAY)
    if corner == 1:               #todo: trennung dkw-Kreuzung
        pygame.draw.line(fenster,DGRAY,(round(-7+cx),round(-7+cy)),(round(7+cx),round(-14+cy)),3)
        pygame.draw.line(fenster,DGRAY,(round(-7+cx),round(14+cy)),(round(7+cx),round(7+cy)),3)
    if corner == 0:    
        pygame.draw.line(fenster,DGRAY,(round(-7+cx),round(-14+cy)),(round(7+cx),round(-9+cy)),3)
        pygame.draw.line(fenster,DGRAY,(round(-7+cx),round(7+cy)),(round(7+cx),round(16+cy)),3)
         
    return


def DWeiche24(x,y):
    track(x,y)
    arrow(x,y,2)
    arrow(x,y,3)
    TurnoutDir(x,y,2,GRAY)
    TurnoutPos(x,y,2,GRAY)
    TurnoutPos(x,y,3,GRAY)
    return

def DWeiche25(x,y):
    track(x,y)
    arrow(x,y,1)
    arrow(x,y,0)
    TurnoutDir(x,y,1,GRAY)
    TurnoutPos(x,y,0,GRAY)
    TurnoutPos(x,y,1,GRAY)
    return
    
def DiagoWeiche(x,y,corner):   # DrawSTurnout, Element 8,9,10,11
    TrackSlant(x,y,corner)
    TrackHLine(x,y,corner)
    DrawDiagonalStand(x,y,0)   # Lage unbekannt
    return

def DrawTurnout(x,y,corner):   # normale Weiche mit Lage init.
    track(x,y)
    arrow(x,y,corner)
    DrawSwitchStand(x,y,0);    # Lage unbekannt   
    return

# -----------------------------------------------
# Lagedarstellung

def TurnoutDir(x,y, turn, color):  # Lageinfo: Gerade
    cx = x * elx + (elx/2)
    cy = y * ely + (ely/2)
    cx = cx + offs
    cy = cy + offs
            
    if (turn == 0) or (turn == 1):
        px1= cx + elx/2 - 18; py1= cy - TRACK/2 + 3;
        px2 = 18; py2 = 3                              #zuvor 5
    elif (turn == 2) or (turn == 3):
        px1= cx - elx/2 +1; py1= cy - TRACK/2 + 3;
        px2 = 18; py2 = 3                              #zuvor 5
    #pygame.draw.rect(fenster,(color),(round(px1),round(py1),round(px2),round(py2)))
    pygame.draw.rect(fenster,(color),(int(px1),int(py1),int(px2),int(py2)))  
    return

def TurnoutsmlDir(x,y, turn, color):  # Lageinfo: Gerade, schmal
    cx = x * elx + (elx/2)
    cy = y * ely + (ely/2)
    cx = cx + offs
    cy = cy + offs
            
    if (turn == 0) or (turn == 1):
        px1= cx + elx/2 - 18; py1= cy - TRACK/2 + 3;
        px2 = 18; py2 = 3
    elif (turn == 2) or (turn == 3):
        px1= cx - elx/2 +1; py1= cy - TRACK/2 + 3;
        px2 = 18; py2 = 3
    pygame.draw.rect(fenster,(color),(round(px1),round(py1),round(px2),round(py2)))  
    return


def TurnoutPos(x,y, turn, color):  # Lageinfo: Bogen
    cx = x * elx + (elx/2)
    cy = y * ely + (ely/2)
    cx = cx + offs
    cy = cy + offs
    
    eckx = elx/2; ecky = ely/2
    px1=eckx-8;  py1=ecky-3
    px2=eckx-7;  py2=ecky-7
    px3=eckx-16; py3=ecky-12
    px4=eckx-18; py4=ecky-8
    
    if (turn == 1):
        py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4
    elif (turn == 2):
        py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4
        px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4
    elif (turn == 3):
        px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4
        
    a1 = round(px1+cx); b1 = round(py1+cy)
    a2 = round(px2+cx); b2 = round(py2+cy)
    a3 = round(px3+cx); b3 = round(py3+cy)
    a4 = round(px4+cx); b4 = round(py4+cy)    
        
    pygame.draw.polygon(fenster,(color),[(a1,b1),(a2,b2),(a3,b3),(a4,b4)])
    return

def TurnoutLong(x,y,corner,color):  # Ausleuchtung Diagonale
    cx = x * elx + (elx/2)
    cy = y * ely + (ely/2)
    cx = cx + offs
    cy = cy + offs
    
    eckx = elx/2; ecky = ely/2
    px1=eckx-52;  py1=ecky-32
    px2=eckx-15;  py2=ecky-8
    px3=eckx-13;  py3=ecky-12
    px4=eckx-50;  py4=ecky-35
    
    if (corner == 1):
        py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4
    elif (corner == 2):
        py1 = -py1; py2 = -py2; py3 = -py3; py4 = -py4
        px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4
    elif (corner == 3):
        px1 = -px1; px2 = -px2; px3 = -px3; px4 = -px4
     
    a1 = round(px1+cx); b1 = round(py1+cy)
    a2 = round(px2+cx); b2 = round(py2+cy)
    a3 = round(px3+cx); b3 = round(py3+cy)
    a4 = round(px4+cx); b4 = round(py4+cy)
        
    pygame.draw.polygon(fenster,(color),[(a1,b1),(a2,b2),(a3,b3),(a4,b4)])
    
    return

def DrawSwitchStand(x, y, SwStand):
    corner = int (StpM[y][x])
    corner = corner & 3
    
    if (SwStand == 0):
        TurnoutDir(x,y, corner, GRAY)
        TurnoutPos(x,y, corner, GRAY)
    elif (SwStand == 1):
        TurnoutPos(x,y, corner, GRAY)
        TurnoutDir(x,y, corner, WHITE)
    elif (SwStand == 2):
        TurnoutDir(x,y, corner, GRAY)
        TurnoutPos(x,y, corner, WHITE)
    return

def DrawDiagonalStand(x,y, SwStand):
    w811 = int(StpM[y][x]) & 0x0F
    cor1 = 0; cor2 = 0
    
    if (w811 == 8):
        cor1 = 2; cor2 = 2
    elif (w811 == 9):
        if (SwStand == 2):
            cor1 = 2; cor2 = 3
        else:
            cor1 = 3; cor2 = 2
    elif (w811 == 10):
        cor1 = 0; cor2 = 0
    elif (w811 == 11):
        if (SwStand == 2):
            cor1 = 0; cor2 = 1
        else:
            cor1 = 1; cor2 = 0
    
    if (SwStand == 0):
        TurnoutDir(x,y, cor2, GRAY)
        TurnoutPos(x,y, cor1, GRAY)
    elif (SwStand == 1):
        TurnoutPos(x,y, cor1, WHITE)       #gray
        TurnoutDir(x,y, cor2, GRAY)      #white
    elif (SwStand == 2):
        TurnoutDir(x,y, cor1, WHITE)       #gray
        TurnoutPos(x,y, cor2, GRAY)      #white
    return

# Ende Lagedarstellung
# ---------------------------------------------------------

# ---------------------------------------------------------

def EleDraw(x, y, Ele):
    Ele = int(Ele)
    if (Ele == 1):                          # Gleis
        track(x,y)
        trackl(x,y,(GRAY))
    elif (Ele >= 4) and (Ele <= 7):         # Knicke
        kink(x,y,Ele & 3)
        arrow(x,y,Ele & 3)
        TurnoutPos(x,y,Ele & 3,GRAY)
    elif (Ele >= 16) and (Ele <= 19):       # Weiche einfach
        DrawTurnout(x,y,Ele & 3)
        
    elif (Ele >= 8) and (Ele <= 11):        # Weiche diagonal
        DiagoWeiche(x,y,Ele & 3)
    elif (Ele == 24):                       # Doppelweichen
        DWeiche24(x,y)
    elif (Ele == 25):
        DWeiche25(x,y)
    elif (Ele == 12) or (Ele == 22):        # DKW und Kreuzung
        DKW(x,y,Ele & 3)
    elif (Ele == 13) or (Ele == 23):        
        DKW(x,y,Ele & 3)
    elif (Ele == 15):                       # sym. Kreuzung
        SymKr(x,y)
    elif (Ele == 20) or (Ele == 21):        # Diagonale
        TrackSlant(x,y,Ele & 3)
        TurnoutLong(x,y,Ele & 3,GRAY)
    elif (Ele == 26) or (Ele == 27):        # Hp+Sh
        DrawM.sigScreen(x,y,Ele,fenster)
        DrawM.ShHscreen(x,y,Ele,fenster)
    elif (Ele == 28) or (Ele == 29):        # Hp
        DrawM.sigScreen(x,y,Ele,fenster)
    elif (Ele == 30) or (Ele == 31):        # Sh
        DrawM.ShScreen(x,y,Ele,fenster)
    return

def checkS(va):                # Gleissperre, Flag noch merken
    c=0
    if isinstance(va,str):
        if va[0]=='G':
            c= int (va[1]+va[2])
    return(c)

def TrPlan(line):
    j=0
    while j < ElanzX:        # 29, Wird Variabel ! xxxxxxxxxxxx
        b =checkS (StpM[line][j])
        if b:
            StpM[line][j]=b
        EleDraw(j,line,int(StpM[line][j]))
        
        j = j+1
    return


def EraseEle(x,y):
    #print("x,y:",x,y)
    pygame.draw.rect(fenster,TABLE,[(x*elx+offs+1,y*ely+offs+1),(60,40)])
    return

def DrawBox(x,y,col):
    #print('Box:',x,y,col)
    pygame.draw.rect(fenster,col,[(x*elx+offs+1,y*ely+offs+1),(60,40)])              
    return                 
                     

def FwegButton(x,y,String):                 # Taste zeichnen
    global GL_Benum
    ex = int(int(B[1]) * elx + offs + elx/2)
    ey = int(int(B[2]) * ely + offs + ely/2)
    pygame.draw.circle(fenster,YELLOW,(ex,ey),6)
    textButt(x,y,String)
    
    ButFld[GL_Benum] =(x<<6)+y,'b'          # Listeneintrag
    #StpM[y][x] = GL_Benum
    GL_Benum = GL_Benum + 1
    return

def WeicheLage(x,y,Adr):                   # Lageumkehr bzw. init
    Element = int(StpM[y][x])
    Lage    = int(Element) >> 6
    Wl=int(Adr)
    if (int(Element) & 0x1F) in range (16,20): # EW    
        #print('Weiche',Adr,Lage)
        if Lage==0:
            Element = int(Element)| 0x40    # Gerade init.
            StpM[y][x] = Element
            
        elif Lage==1:
            Element = int(Element) & 0x3F
            Element = int(Element) | 0x80   # Bogen
            StpM[y][x] = Element
            Wl=-Wl
        elif Lage==2:
            Element = int(Element) & 0x3F
            Element = int(Element) | 0x40   # Gerade
            StpM[y][x] = Element
                    
        Lage = StpM[y][x] >> 6
        DrawSwitchStand(x,y,Lage)
        
    elif (int(Element) & 0x1F) in range (8,12): # EW Diagonal
        if Lage==0:
            Element = int(Element)| 0x40    # Gerade init.
            StpM[y][x] = Element
            
        elif Lage==1:
            Element = int(Element) & 0x3F
            Element = int(Element) | 0x80   # Bogen
            StpM[y][x] = Element
            Wl=-Wl
        elif Lage==2:
            Element = int(Element) & 0x3F
            Element = int(Element) | 0x40   # Gerade
            StpM[y][x] = Element
                    
        Lage = StpM[y][x] >> 6
        DrawDiagonalStand(x,y,Lage)            
        
    pygame.display.flip()
        
    return Wl


def DrawDWStand(x,y,Adr):          #manuelle Schaltung
    print('DW, Adr:',Adr)
    Element = int(StpM[y][x])                 # 24:_\__   25: __/_
    ele     = Element & 0x1F                  #     /           \
    swp0    = StpA[y][x] & ADRSWAP  # Bit
    swp1    = 0                     # temporär
    Lage    = Element >> 6
    Wl=int(Adr)
    if Lage==0:                               # 1.Klick ==
        Lage=2        
        if ele == 24:
            TurnoutDir(x,y,2,WHITE)
        else:
            TurnoutDir(x,y,1,WHITE)
        Wswitch(Adr,swp0)
        Wswitch(-(Adr+1),swp1)
        
    elif Lage==1:
        Lage=2
        if ele == 24:
            TurnoutPos(x,y,2,DGRAY)
            TurnoutDir(x,y,2,WHITE)
        else:
            TurnoutPos(x,y,1,DGRAY)
            TurnoutDir(x,y,0,WHITE)
        Wswitch(Adr,swp0)
        Wswitch(-(Adr+1),swp1)
        
    elif Lage==2:   
        Lage=3
        if ele == 24:
            TurnoutDir(x,y,2,DGRAY)
            TurnoutPos(x,y,3,WHITE)
            Wswitch(Adr,swp0)
            Wswitch(Adr+1,swp1)
        else:
            TurnoutDir(x,y,1,DGRAY)                   # 2.Klick \\
            TurnoutPos(x,y,0,WHITE)
            Wswitch(-Adr,swp0)
            #Wswitch(-(Adr+1),swp)
        
    elif Lage==3:
        Lage=1
        if ele == 24:
            TurnoutPos(x,y,3,DGRAY)
            TurnoutPos(x,y,2,WHITE)
            Wswitch(-Adr,swp0)
        else:
            TurnoutPos(x,y,0,DGRAY)                  # 3.Klick //
            TurnoutPos(x,y,1,WHITE)
            Wswitch(Adr,swp0)
            Wswitch(Adr+1,swp1)
        
    print('Lage manuell:',Lage)
    pygame.display.update()
    StpM[y][x] = (int(Element) & 0x3F) | (int(Lage) << 6)   #neue Lage
    return


def parserF(F):          # Zerlegt Fahrweg in Einzelweichen
    print('parserF:',F)
    semicnt = 0    
    ncnt    = 0
    Fw      =[]
    for _ in range(0,20):   # max Anzahl Weiche je Fweg
        Fw.append(0)
        
    u = F[0]        
    if u=='F':        
        
        for k in range(1,len(F)):
            u=F[k]              
            if u==';':
                semicnt += 1
                if ncnt !=0:
                    if semicnt == 1:                     
                        ncnt =0
                        num  =0
                    else:
                        Fw[semicnt-2] = num              #ex B[]
                        #print("x,val:",semicnt-2,num)    
                        ncnt = 0
                        num = 0
            else:
                ncnt = ncnt + 1        
                if ncnt > 1:        
                    num = num + u 
                else:    
                    num = u
                    
    return Fw,semicnt-1   # Anz = semicnt-1


def Suchcd(wadr):                         # Lageinfo DKW cd
    rv = -1
    for i in range (0,Wcnt):        
        if wadr==int(Wlist[i][3]) & ADRMSK:
            rv = i
            break           
    
    return rv




def Suchxy(Wadr):                         # Einzelaufruf fuer jede Weiche in Fweg
    global DWad1
    global DWlage
    global DW1x
    global DW1y
    global DWele
    
    global DKWadab 
    global DKWlgab
    global DKWx
    global DKWy
    
    ad =int(Wadr)
    print('such:',Wadr)                   # mit Lage(+,-)
    bogen = 0
    if ad < 0:  
        bogen = 1
        ad = -ad                         # für die Suche abs(ad)
    
    print('such ad',ad)
    for i in range (0,Wcnt):        
        if ad==int(Wlist[i][3]) & ADRMSK:
            x    = int(Wlist[i][0])
            y    = int(Wlist[i][1])
            swap = int(StpA[y][x]) & ADRSWAP  # Bit
                                     
            ele  = int(StpM[y][x]) & 0x1F
            st   = int(StpM[y][x]) & 0xC0
            
            if int(ele) in range (24,26): # DW                
                DWad1 = Wadr
                DWlage = st>>6
                DW1x   = x
                DW1y   = y
                DWele  = ele
                break
            
            elif int(ele) in range (12,14): #DKW
                DKWadab = Wadr
                DKWlgab = st>>6
                DKWx    = x
                DKWy    = y
                break
            
            else:
                print('EW:',ele)
                if st == 0:                
                    WeicheLage(x,y,Wadr)                    
                    Wswitch(Wadr,swap)         # Lage jetzt gerade
                    st= int(StpM[y][x]) & 0xC0 # aktualisiert
                    time.sleep(1)
                    
                if st == 0x80 and bogen==0:    # Weiche Bogen, gerade verlangt
                    WeicheLage(x,y,Wadr)
                    Wswitch(ad,swap)
                if st == 0x40 and bogen==1:    # Weiche Gerade, Bogen verlangt
                    WeicheLage(x,y,Wadr)
                    Wswitch(Wadr,swap)                
            break   # gefunden
        
 #------------------------------------------------------------ DW ----------------------------            
        if DWad1 != 0:   # nicht gefunden, es könnte die 2.Adr DW sein
            DWlgNeu = 0
            print('ad1,ad2:',DWad1,Wadr)
            if int(DWad1) > 0 and int(Wadr) > 0:
                DWlgNeu = 2
            elif int(DWad1) > 0 and int(Wadr) < 0:
                if DWele == 24:
                    DWlgNeu = 3
                else:
                    DWlgNeu = 1
            elif int(DWad1) < 0:
                if DWele ==24:
                    DWlgNeu = 1        #1
                else:
                    DWlgNeu = 3        #3
            print('Lalt,Lneu:',DWlage,DWlgNeu)
            
            if DWele == 24:                  #lösche alte Lage
                TurnoutPos(DW1x,DW1y,2,DGRAY)
                TurnoutDir(DW1x,DW1y,2,DGRAY)
                TurnoutPos(DW1x,DW1y,3,DGRAY)
            else:
                TurnoutPos(DW1x,DW1y,1,DGRAY)
                TurnoutDir(DW1x,DW1y,1,DGRAY)
                TurnoutPos(DW1x,DW1y,0,DGRAY)
                
            swp0 = int(StpA[DW1y][DW1x]) & ADRSWAP  # Bit
            swp1 = 0                                # temporär
            Adr = int(DWad1)            
            
            if DWele == 24:    # DW 24
                if DWlgNeu == 2:                
                    TurnoutDir(DW1x,DW1y,2,WHITE)
                    Wswitch(Adr,swp0)
                    Wswitch(-(Adr+1),swp1)    
                elif DWlgNeu == 1:
                    TurnoutPos(DW1x,DW1y,2,WHITE)
                    Wswitch(Adr,swp0)    #unklar, soll -Adr
                elif DWlgNeu == 3:
                    TurnoutPos(DW1x,DW1y,3,WHITE)
                    Wswitch(Adr,swp0)
                    Wswitch(Adr+1,swp1)
            else:                                 # DW25
                print("Lage 25",DWlgNeu)
                
                if DWlgNeu == 2:                  #
                    TurnoutDir(DW1x,DW1y,1,WHITE)
                    Wswitch(Adr,swp0)
                    Wswitch(-(Adr+1),swp1)    
                elif DWlgNeu == 1:                #1
                    TurnoutPos(DW1x,DW1y,1,WHITE)
                    Wswitch(Adr,swp0)
                    Wswitch(Adr+1,swp1)
                elif DWlgNeu == 3:                #3
                    TurnoutPos(DW1x,DW1y,0,WHITE)
                    Wswitch(Adr,swp0)
                    Wswitch(-(Adr+1),swp1)    
                
                
            
            pygame.display.update()
            StpM[DW1y][DW1x] = (int(StpM[DW1y][DW1x]) & 0x3F) | (int(DWlgNeu) << 6)   #neue Lage
            
            DWad1  = 0
            DWlage = 0
            break        
        
 #------------------------------------------------------------ DKW ---------------------------        
        elif DKWadab != 0:              # 2.Adr DKW möglich
            print('DKWad1,DKWad2:',DKWadab,Wadr)
            cd = Suchcd(abs(int(DKWadab)))                      #Wadr: nil
             #print('index:',cd)
            Lage_cd = int(Wlist[cd][5]) >> 6
             #print('Lage ab,cd',DKWlgab,Lage_cd)
             
            x   = DKWx
            y   = DKWy
            Adr = int(DKWadab)
             
            Element = StpM[DKWy][DKWx]
            DKWele  = int(Element) & 0x1F
            Lage_ab = int(Element) >> 6    
            swpab =  int(Wlist[cd][5]) & 0x01
            swpcd = (int(Wlist[cd][5]) & 0x02) >> 1
                         
            if int(Wadr) > 0:    
                print('A4')
                Wlist[cd][5] = int(Wlist[cd][5]) & 0x3F  # Abschnitt 4
                Wlist[cd][5] = int(Wlist[cd][5]) | 0x40  # Gerade
                if DKWele == 13:   
                    TurnoutPos(x,y,3,GRAY)
                else:
                    TurnoutPos(x,y,2,GRAY)
                TurnoutDir(x,y,3,WHITE)                  # =-
                Wswitch(int(Wadr),swpcd)                     #
                
            else:
                print('A3')
                Wlist[cd][5] = int(Wlist[cd][5]) & 0x3F  # Abschnitt 3
                Wlist[cd][5] = int(Wlist[cd][5]) | 0x80  # Bogen
                if DKWele == 13:
                    TurnoutPos(x,y,3,WHITE)                  # //unten
                else:
                    TurnoutPos(x,y,2,WHITE)
                 
                 #TurnoutDir(x,y,0,GRAY)
                TurnoutDir(x,y,2,GRAY)          # links White löschen
                Wswitch(int(Wadr),swpcd)    
                 
             
            if int(DKWadab) > 0:
             
                print('A2')
                Element = int(Element) & 0x3F   # Abschnitt 2
                Element = int(Element) | 0x40   # Gerade
                StpM[y][x] = Element
                if DKWele == 13:
                    TurnoutPos(x,y,1,GRAY)
                else:
                    TurnoutPos(x,y,0,GRAY)
                TurnoutDir(x,y,1,WHITE)         #-=
                Wswitch(Adr,swpab)              #Adr
                 
            else:
                print('A1')
                Element = int(Element) & 0x3F   # Abschnitt 1
                Element = int(Element) | 0x80   # Bogen
                StpM[y][x] = Element
                 
                if DKWele == 13:
                    TurnoutPos(x,y,1,WHITE)     # //oben
                else:
                    TurnoutPos(x,y,0,WHITE)
                TurnoutDir(x,y,1,GRAY)
                Wswitch(Adr,swpab)             
                 
            print('Lage ab:',int(StpM[y][x]) >> 6)
            print('Lage cd:',int(Wlist[cd][5]) >> 6)
             
            pygame.display.update()
            DKWadab = 0
            DKWlgab = 0
    return


def SuchBut(pk):
    ret = -1
    for i in range(0,GL_Benum):
        #print('Bsuch',i)
        #print('BFld:',ButFld[i])
        if ButFld[i][0] == pk:
            ret = i
            break
    return ret

def SuchMsg(p):
    ret = -1
    for i in range(0,GL_Menum):
        #print('Msuch',i)        
        if MsgFld[i][0] == p:
            ret = i
            break
    return ret


def checkWlist():
    for i in range (0,Wcnt):
        print('x,y,Adr:',Wlist[i][0],Wlist[i][1],Wlist[i][3])

    return


def Wswitch(Adr,swp):
    Adr = int(Adr)            # !! ohne int: aus 10 wird nichts ' '
    if swp != 0:
        Adr = Adr * (-1)
        
    print('Adr,swp',Adr,swp)    
    enc = str.encode('Switch '+str(Adr)+'\n')
    ser.write(enc)
    enc = str.encode(str(Adr)+'\n')
    ser.write(enc)    
    return


def SignalCheckF(x,y):
    Sig = StpS[y][x] & 0x1F
    Sad = StpA[y][x]
    Lage= StpS[y][x] >> 6
    
    LSh = 0
    LHp = RED

    if Lage == 0:
        StpS[y][x] = Sig | 0x40
        LSh = 1
        LHp = GREEN
    elif Lage == 1:
        StpS[y][x] = StpS[y][x] & 0x3F
        StpS[y][x] = StpS[y][x] | 0x80

    elif Lage == 2:
        StpS[y][x] = StpS[y][x] & 0x3F
        StpS[y][x] = StpS[y][x] | 0x40
        LSh = 1
        LHp = GREEN
        
    if LSh == 0:
        Sad = -Sad
    
    if Sig in range (26,28):                  # Hp mit Sh
        if Sad != 0:
            if LSh==1:                        # Fahrt
                
                Wswitch(Sad,0)                # Hp            
                if Sad < 0:                
                    Wswitch(-(abs(Sad)+1),0)  # Sh
                else:
                    Wswitch(Sad+1,0)
            else:                             # Halt (Schaltreihenfolge tausch)
                if Sad < 0:                
                    Wswitch(-(abs(Sad)+1),0)  # Sh
                else:
                    Wswitch(Sad+1,0)
                Wswitch(Sad,0)                # Hp
                
        DrawM.ShHaspect(x,y,Sig,LSh,fenster)
        DrawM.HpAspect(x,y,Sig,LHp,fenster)
        
    elif Sig in range (28,30):  # Hp
        if Sad != 0:
            Wswitch(Sad,0)
        DrawM.HpAspect(x,y,Sig,LHp,fenster)
        
    elif Sig in range (30,32):  # Sh
        if Sad != 0:
            Wswitch(Sad,0)
        DrawM.Shaspect(x,y,Sig,LSh,fenster)
    
    pygame.display.update()
    return                                   # SignalCheckF()


def SignalCheckR(x,y):
    Sig = StpS[y][x] & 0x1F
    Sad = StpA[y][x]
    Lage= StpS[y][x] >> 6
    
    LSh = 0
    
    if Lage == 0:
        StpS[y][x] = Sig | 0x40
        LSh = 1
        
    elif Lage == 1:
        StpS[y][x] = StpS[y][x] & 0x3F
        StpS[y][x] = StpS[y][x] | 0x80

    elif Lage == 2:
        StpS[y][x] = StpS[y][x] & 0x3F
        StpS[y][x] = StpS[y][x] | 0x40
        LSh = 1
                
    if LSh == 0:
        Sad = -Sad
    
    if Sig in range (26,28):                  # Hp mit Sh
        if Sad != 0:
            if LSh==1:                        # Fahrt                          
                if Sad < 0:                
                    Wswitch(-(abs(Sad)+1),0)  # Sh
                else:
                    Wswitch(Sad+1,0)
            else:                             # Halt (Schaltreihenfolge tausch)
                if Sad < 0:                
                    Wswitch(-(abs(Sad)+1),0)  # Sh
                                
        DrawM.ShHaspect(x,y,Sig,LSh,fenster)
        
    elif Sig in range (30,32):  # Sh
        if Sad != 0:
            Wswitch(Sad,0)
        DrawM.Shaspect(x,y,Sig,LSh,fenster)
    
    pygame.display.update()
    return                        # SignalCheckR()



def SignalBox(x,y):               #Umschaltung Signal Zug-oder R-Fstr
    global GL_Sigzr
    GL_Sigzr += 1
    GL_Sigzr = GL_Sigzr & 0x01
    DrawBox(x,y,RED)        
    if int(GL_Sigzr) == 1:
        textStrC(x,y,'Rz',WHITE) 
    else:
        textStrC(x,y,'Zr',BLACK)
    pygame.display.update()
    return



def SelectBox(x,y,num):          # Meldeboxen zeichnen und in Liste
    global GL_Menum
    print('i:',x,y,num)
    if int(num) == 3:    
        DrawBox(x,y,LBLUE)
        textStr(x,y,'a/b')
        MsgFld[GL_Menum] =(x<<6)+y,num
        GL_Menum += 1
        pygame.display.update()
    elif int(num) == 5:
        DrawBox(x,y,RED)
        textStr(x,y,'Zr')
        MsgFld[GL_Menum] =(x<<6)+y,num
        GL_Menum += 1
        pygame.display.update()
    return


def DKWbox(x,y):                # Umschaltung ab/cd
    global GL_DKWside
    GL_DKWside += 1
    GL_DKWside = GL_DKWside & 0x01
    DrawBox(x,y,LBLUE)        
    if int(GL_DKWside) == 1:
        textStr(x,y,'c/d') 
    else:
        textStr(x,y,'a/b')
    pygame.display.update()
    return


def DrawKey(x,y,Bez,Adr):      #Tasten Für Schaltadressen
    global GL_Benum
    ex = int(int(B[1]) * elx + offs + elx/2)
    ey = int(int(B[2]) * ely + offs + ely/2)
    pygame.draw.circle(fenster,BLACK,(ex,ey+5),8,1)
    pygame.draw.circle(fenster,BLACK,(ex,ey+5),3)
    textButt(x,y,Bez)
    
    ButFld[GL_Benum] =(x<<6)+y,'K'          # Listeneintrag    
    GL_Benum = GL_Benum + 1
    
    StpA[y][x] = int(Adr)         # Adresse    
    return

def KeySwitch(x,y,Adr):
    Element = int(StpM[y][x])
    #ele     = Element & 0x1F  #var.unused
    Lage    = int(Element) >> 6
    if Lage==0:
        Element = int(Element)| 0x40    # Aus init.
        StpM[y][x] = Element
            
    elif Lage==1:
        Element = int(Element) & 0x3F
        Element = int(Element) | 0x80   # Ein
        StpM[y][x] = Element
        Adr = -Adr
        
    elif Lage==2:
        Element = int(Element) & 0x3F
        Element = int(Element) | 0x40   # Aus
        StpM[y][x] = Element
                
    Lage = StpM[y][x] >> 6
    print('Lage neu:',Lage)
    ex = x * elx + offs + elx/2
    ey = y * ely + offs + ely/2
    
    if Lage==1:
        pygame.draw.circle(fenster,WHITE,(int(ex),int(ey+5)),8)
    else:
        pygame.draw.circle(fenster,GRAY,(int(ex),int(ey+5)),8)
    
    Wswitch(Adr,0)
    pygame.display.update()
    return


def DrawSw1Adkw(x,y,Adr):                    # DKW mit einem Antrieb
    ex = int(x * elx + offs + elx/2)
    ey = int(y * ely + offs + ely/2)
    Element = int(StpM[y][x])                # Schalten wie EW    
    ele     = Element & 0x1F                 # Darstellung different    
    Lage    = int(Element) >> 6
    Wl=int(Adr)
    if (int(Element) & 0x1F) in range (12,14): # DKW ein Antrieb   
        #print('1ADKW',Adr,Lage)
        if Lage==0:
            Element = int(Element)| 0x40    # Gerade init.
            StpM[y][x] = Element
            TurnoutsmlDir(x,y,0,WHITE)
            TurnoutsmlDir(x,y,2,WHITE)
            if ele == 13:
                TurnoutPos(x,y,1,WHITE)         # //oben
                TurnoutPos(x,y,3,WHITE)
            else:
                TurnoutPos(x,y,0,WHITE)         # \\oben
                TurnoutPos(x,y,2,WHITE)
            
        elif Lage==1:
            Element = int(Element) & 0x3F
            Element = int(Element) | 0x80   # Bogen
            StpM[y][x] = Element
            Wl=-Wl
            pygame.draw.circle(fenster,WHITE,(ex,ey),5)
        elif Lage==2:
            Element = int(Element) & 0x3F
            Element = int(Element) | 0x40   # Gerade
            StpM[y][x] = Element
            pygame.draw.circle(fenster,BLACK,(ex,ey),5)
        
        Wswitch(Wl,swap)
        pygame.display.flip()
    return


def DrawSwDKW(x,y,Adr):                      # --------- DKW manelle Schsltung -------------
    global GL_DKWside
    print('DKWbit',(StpA[y][x] & ADR1DKW))
    if (StpA[y][x] & ADR1DKW) == ADR1DKW:
        DrawSw1Adkw(x,y,Adr)                 # DKW mit einem Antrieb
        return
    
    Element = int(StpM[y][x])
    ele     = Element & 0x1F
    Lage_ab = int(Element) >> 6
    cd = Suchcd(Adr)
    swpab =  int(Wlist[cd][5]) & 0x01
    swpcd = (int(Wlist[cd][5]) & 0x02) >> 1

    if ele in range (12,14): # DKW      
        #print('Wlist :',Wlist[cd][5])        
        if Lage_ab==0:
            Element = int(Element)| 0x40    # Gerade init.
            StpM[y][x] = Element            # ab init
            TurnoutDir(x,y,0,WHITE)
            Wswitch(Adr,swpab)
            
            Wlist[cd][5] = int(Wlist[cd][5]) & 0x3F
            Wlist[cd][5] = int(Wlist[cd][5]) | 0x40
            TurnoutDir(x,y,2,WHITE)
            Wswitch(Adr+1,swpcd)
        else:                               # DKW ist init.
            if GL_DKWside == 1:
                if Lage_ab==1:                      # ab
                    Element = int(Element) & 0x3F   # Abschnitt 1
                    Element = int(Element) | 0x80   # Bogen
                    StpM[y][x] = Element
                    if ele == 13:
                        TurnoutDir(x,y,1,GRAY)
                        TurnoutPos(x,y,1,WHITE)         # //oben
                    else:
                        TurnoutDir(x,y,1,GRAY)
                        TurnoutPos(x,y,0,WHITE)         # \\oben
                    Wswitch(-Adr,swpab)
                    
                elif Lage_ab==2:
                    Element = int(Element) & 0x3F   # Abschnitt 2
                    Element = int(Element) | 0x40   # Gerade
                    StpM[y][x] = Element
                    if ele == 13:
                        TurnoutPos(x,y,1,GRAY)
                        TurnoutDir(x,y,1,WHITE)         #-=
                    else:
                        TurnoutPos(x,y,0,GRAY)
                        TurnoutDir(x,y,1,WHITE)         #-=
                    Wswitch(Adr,swpab)
                    
            else:                                            # cd
                Lage_cd = int(Wlist[cd][5]) >> 6
                if Lage_cd==1:
                    Wlist[cd][5] = int(Wlist[cd][5]) & 0x3F  # Abschnitt 3
                    Wlist[cd][5] = int(Wlist[cd][5]) | 0x80  # Bogen
                    if ele == 13:         
                        TurnoutPos(x,y,3,WHITE)                  # //unten
                        TurnoutDir(x,y,3,GRAY)
                    else:
                        TurnoutPos(x,y,2,WHITE)                  # \\unten
                        TurnoutDir(x,y,3,GRAY)
                    Wswitch(-(Adr+1),swpcd)
                    
                elif Lage_cd==2:
                    Wlist[cd][5] = int(Wlist[cd][5]) & 0x3F  # Abdef Shaspect(x,y,Styp,Asp,fenster):  schnitt 4
                    Wlist[cd][5] = int(Wlist[cd][5]) | 0x40  # Gerade
                    if ele == 13:
                        TurnoutPos(x,y,3,GRAY)
                        TurnoutDir(x,y,3,WHITE)                  # =-
                    else:
                        TurnoutPos(x,y,2,GRAY)
                        TurnoutDir(x,y,3,WHITE)                  # =-
                    Wswitch(Adr+1,swpcd)                    
        
        print('Lage ab:',int(StpM[y][x]) >> 6)
        print('Lage cd:',int(Wlist[cd][5]) >> 6)
        
        pygame.display.flip()

        return

# ----------------------------------------------------------
# Fortsetzung Start

fenster.fill(TABLE)

grid()

pygame.display.flip()


# ----------------------------------------------------------

for m in range (0,19):           # Gleisbild 19: Variabel, Vertikal je nach Größe Gleisbild
    TrPlan(m)

pygame.display.flip()


for p in range (0,Lcnt):           # &;S; Signale  
    B = RDstr.getSig(p)
    if B[0] == 'S':
        #print("Signal: ",B[0],B[1],B[2],B[3],B[4])
        StpS[int(B[2])][int(B[1])] = int(B[4])
        StpA[int(B[2])][int(B[1])] = int(B[5])
        
        if (int(B[4])==26) or (int(B[4])==27):            
            DrawM.sigScreen(int(B[1]),int(B[2]),int(B[4]),fenster)
            DrawM.ShHscreen(int(B[1]),int(B[2]),int(B[4]),fenster)
            
        elif (int(B[4])==29) or (int(B[4])==28):
            DrawM.sigScreen(int(B[1]),int(B[2]),int(B[4]),fenster)
            
        elif (int(B[4])==31) or (int(B[4])==30):
            DrawM.ShScreen(int(B[1]),int(B[2]),int(B[4]),fenster)    
        
        DrawM.sigName  (int(B[1]),int(B[2]),str(B[3]),int(B[4]),fenster,font)
        
    elif B[0] == 't':
        textInfo(int(B[1]),int(B[2]),str(B[3]))
        
    elif B[0] == 'b':                            # button Fweg
        FwegButton(int(B[1]),int(B[2]),str(B[3]))
        
    elif B[0] == 'i':                            # Melder
        SelectBox(int(B[1]),int(B[2]),str(B[3]))
        
    elif B[0] == 'K':
        DrawKey(int(B[1]),int(B[2]),str(B[3]),int(B[5]))
        

for p in range (0,100):                          # *, Weichen  
    B = RDstr.getStar(p)
    if B[1] != 0:                                # y, unklar !!!
        
        textInfo(int(B[0]),int(B[1]),str(B[2]))  # Beschriftungen
        
        if int(B[5]) != 0:
            print('name,B[5]',B[2],hex(int(B[5])))
            if int(B[5]) < 4:                            # EW oder DKW 2 Antriebe
                B[3] = int(B[3]) | ADRSWAP     
                StpA[int(B[1])][int(B[0])] = int(B[3])   # Adresse
                
            else:                                        # DKW ein Antrieb                   
                StpA[int(B[1])][int(B[0])] = int(B[3]) | ADR1DKW   # Adresse und Flag
                if int(B[5]) == 5:                        # swap
                    StpA[int(B[1])][int(B[0])] = StpA[int(B[1])][int(B[0])] | ADRSWAP
        else:   #B[5] ist leer
            StpA[int(B[1])][int(B[0])] = int(B[3])   # Adresse    
        
        Wlist[Wcnt]=B                            #der ganze Vektor wird geschrieben
        #print('Flg:',Wlist[Wcnt][5],StpA[int(B[1])][int(B[0])])
        Wcnt +=1

print('Wcnt:',Wcnt)
#for w in range (0,Wcnt):
#    print('w',Wlist[w])

print("lenY:",len(StpM[0]))

F,var = RDstr.getFweg()
print('Anzahl Fwege: ',var)
print('F1: ',F[1])

# -----------------------------------------------------------    

for n in range (1,4):            # Weichenumlauf
    DrawM.ShHaspect(4,3,27,1,fenster)
    DrawM.ShHaspect(6,5,26,1,fenster)
    DrawM.Shaspect(6,8,31,1,fenster)
    DrawM.Shaspect(2,2,30,1,fenster)
    DrawM.HpAspect(7,6,28,GREEN,fenster)
    DrawM.HpAspect(4,3,27,GREEN,fenster)
    #TurnoutDir(13,0,3,WHITE)
    pygame.display.flip()
    time.sleep(1)
    
    DrawM.ShHaspect(4,3,27,0,fenster)
    DrawM.ShHaspect(6,5,26,0,fenster)
    DrawM.Shaspect(6,8,31,0,fenster)
    DrawM.Shaspect(2,2,30,0,fenster)
    DrawM.HpAspect(7,6,28,RED,fenster)
    DrawM.HpAspect(4,3,27,RED,fenster)
    #TurnoutPos(13,0,2,WHITE)
    pygame.display.flip()
    time.sleep(1)
    

LEFT  = 1
RIGHT = 3
fetch = 0

p     = 0                # Array, Einzelweichen eine Fahrweges
l     = 0                # Anzahl der Einzelweichen

#checkWlist() #Liste Weichen mit Koord. und Adr.
print('Bnum:',GL_Benum)
#for n in range(0,GL_Benum):
#    print(ButFld[n])

aktZeit   = 0
davorZeit = round(time.time() * 1000)
TCONST    = 10000

#fenster=pygame.display.set_mode(size)
 
while True:
    
    aktZeit = round(time.time() * 1000)
    if aktZeit - davorZeit > TCONST:
        davorZeit = aktZeit
        pygame.draw.rect(fenster,TABLE,[(4*elx+offs+8,dim_y*ely+offs+10),(50,25)])
        textStr(4,dim_y,'timeout')#print('timeout')
    
    if ser.in_waiting > 0:
        line = ser.readline()
        davorZeit = round(time.time() * 1000)
        
        if line[0] != 0x00:
            if line[0] == 0x5F:                # Statusmeldungen
                
                pygame.draw.rect(fenster,TABLE,[(6*elx+offs+8,dim_y*ely+offs+10),(50,25)])
                #sel = ord(line[1]) - ord('0')    # char to int(ascii)!
                sel = int(line[1]) - ord('0')     # char to int
                print('sel=',sel)
                if sel == 0:
                    farbe = WHITE
                elif sel == 1:
                    farbe = YELLOW
                elif sel == 2:
                    farbe = RED
                else:
                    farbe = LGRAY
                pygame.draw.circle(fenster,farbe,(6*elx+offs+31,dim_y*ely+offs+10),9)
                line = line.decode('utf-8')                
                textStrS(6,dim_y,line.strip())
            
            elif line[0] > 0x39:               # Info Meldungen
                pygame.draw.rect(fenster,TABLE,[(5*elx+offs+8,dim_y*ely+offs+10),(50,25)])
                line = line.decode('utf-8')
                line = line[:7]
                textStr(5,dim_y,line.strip())
                         
    
            else:                              # Sequenzzähler
                pygame.draw.rect(fenster,TABLE,[(3*elx+offs+2,dim_y*ely+offs+10),(50,25)])
                textStr(3,dim_y,int(line))    
                       
                pygame.display.update()
    
    for event in pygame.event.get():
        
        if event.type == pygame.MOUSEMOTION:
            posX, posY = pygame.mouse.get_pos()
            posX = int((posX-offs)/elx)
            posY = int((posY-offs)/ely)
            #print("posY:",posY)
            Element = 0;
            
            if (posY <= dim_y and posX < dim_x):
                Element = StpM[posY][posX]    
                pygame.draw.rect(fenster,TABLE,[(0*elx+offs+8,dim_y*ely+offs+10),(50,25)])
                pygame.draw.rect(fenster,TABLE,[(1*elx+offs+8,dim_y*ely+offs+10),(50,25)])
                textStr(1,dim_y,Element)
                textStr(0,dim_y,str(posX)+"/"+str(posY))
                pygame.display.update()
                    
        if (event.type == pygame.MOUSEBUTTONDOWN) and (posY <= ElanzY):
            print('Y:',posY)
            Adress = StpA[posY][posX] & ADRMSK
            swap   = StpA[posY][posX] & ADRSWAP  # Bit
            El     = int(StpM[posY][posX]) & 0x1F
            # MouseButton
            print('El',El)
            if El <= 3:     # Signal oder Button                
                Sig = StpS[posY][posX] & 0x1F
                if Sig in range (26,32):            # Signal                    
                    if GL_Sigzr == 0:                        
                        SignalCheckF(posX,posY)     # Hp und Sh
                    else:
                        SignalCheckR(posX,posY)     # nur Sh
                        
                else:                             # evtl. Button oder Key
                    print('Such El',El)
                    fnd = SuchBut((posX<<6)+posY)       # Fweg Button oder Key
                    
                    if fnd >= 0:
                        typ = ButFld[fnd][1]
                        if typ == 'b':                  # Fweg
                            print(F[fnd])
                            p,l=parserF(F[fnd])
                            print('AnzW:',l)
                            for w in range (0,l):       # Weichen eines Fweges
                                print(p[w])
                                Suchxy(p[w])
                        elif typ == 'K':                # Key (Schalttaste)
                            print('Key found at:',posX,posY)
                            KeySwitch(posX,posY,Adress)        # Key Schalten, Anzeigen
                            
                    else:
                        fnd = SuchMsg((posX<<6)+posY)   # Msg-Feld
                        print('found',fnd)
                        if fnd >= 0:
                            if int(MsgFld[fnd][1]) == 3:
                                DKWbox(posX,posY)
                            elif int(MsgFld[fnd][1]) == 5:
                                SignalBox(posX,posY)         
                            
            else:                             # Weichen
                if Adress != 0:
                    EraseEle(2,dim_y)
                    textStr(2,dim_y,Adress)
                    
                    if El in range (16,20):   # EW                       
                        Ladr = WeicheLage(posX,posY,Adress)                
                        Wswitch(Ladr,swap)
                        
                    elif El in range (8,12):  #Diagonal EW
                        Ladr = WeicheLage(posX,posY,Adress)                
                        Wswitch(Ladr,swap)
                    
                    elif El in range (24,26): # DW
                        DrawDWStand(posX,posY,Adress)
                        
                    elif El in range (12,14): #DKW
                        print('maus',El)
                        DrawSwDKW(posX,posY,Adress)
                        
                                
        if event.type == pygame.QUIT:
            print('Rasp STOP')                    #
            enc = str.encode('Rasp STOP'+'\n')
            ser.write(enc)
            time.sleep(2)
            ser.close()
            pygame.quit()            
            exit
   
       
    
        
